/* FCKeditor.java

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Mon Dec 26 20:57:21     2005, Created by tomyeh
}}IS_NOTE

Copyright (C) 2005 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
package org.zkforge.fckez;

import org.zkoss.lang.Objects;

import org.zkoss.zk.ui.AbstractComponent;
import org.zkoss.zk.ui.event.Events;
import org.zkoss.zk.ui.ext.client.Inputable;
import org.zkoss.zk.au.AuScript;

/**
 * The component used to represent
 * &lt;a href="http://www.fckeditor.net/"&gt;FCKeditor&tl;/a&gt;
 *
 * @author tomyeh
 * @version $Revision: 1.6 $ $Date: 2006/03/31 08:38:55 $
 */
public class FCKeditor extends AbstractComponent {
	private String _value = "";
	private String _width = "100%";
	private String _height = "200px";
	private String _tbset;
	/** Used by setTextByClient() to disable sending back the value */
	private String _txtByClient;

	/** Returns the value in this FCKeditor.
	 */
	public String getValue() {
		return _value;
	}
	/** Sets the value for this FCKeditor.
	 */
	public void setValue(String value) {
		if (value == null) value = "";
		if (!value.equals(_value)) {
			_value = value;
			if (_txtByClient == null || !Objects.equals(_txtByClient, value)) {
				_txtByClient = null;
				smartUpdate("value", value);
			}
		}
	}

	/** Returns the toolbar set of this FCKeditor.
	 * <p>Default: null
	 */
	public String getToolbarSet() {
		return _tbset;
	}
	/** Sets the value for this FCKeditor.
	 */
	public void setToolbarSet(String tbset) {
		if (tbset != null && tbset.length() == 0) tbset = null;
		if (!Objects.equals(tbset, _tbset)) {
			_tbset = tbset;
			smartUpdate("tbset", tbset);
		}
	}

	/** Returns the width of this FCKeditor.
	 * <p>Default: 100%
	 */
	public String getWidth() {
		return _width;
	}
	/** Sets the width of this FCKeditor.
	 */
	public void setWidth(String width) {
		if (width != null && width.length() == 0) width = null;
		if (!Objects.equals(width, _width)) {
			_width = width;
			smartUpdate("width", width);
		}
	}
	/** Returns the height of this FCKeditor.
	 * <p>Default: 200px
	 */
	public String getHeight() {
		return _height;
	}
	/** Sets the height of this FCKeditor.
	 */
	public void setHeight(String height) {
		if (height != null && height.length() == 0) height = null;
		if (!Objects.equals(height, _height)) {
			_height = height;
			smartUpdate("height", height);
		}
	}

	/** Returns the HTML attributes for this tag.
	 * <p>Used only for component development, not for application developers.
	 */
	public String getOuterAttrs() {
		return Events.isListenerAvailable(this, "onChange", true) ?
			" z.onChange=\"true\"": null;
	}
	/** Returns the configuration in String.
	 * <p>Used only for component development, not for application developers.
	 */
	public String getConfigString() {
		return "";
	}

	//-- Super --//
	/** Not childable. */
	public boolean isChildable() {
		return false;
	}
	protected Object newExtraCtrl() {
		return new Inputable() {
			/** Called by the browser to notify the content is changed. */
			public void setTextByClient(String text) {
				_txtByClient = text;
				try {
					setValue(text);
				} finally {
					_txtByClient = null;
				}
			}
		};
	}
}
